
% Let us perform the operation in Koller & Friedman fig 7.8
% We store the dimensions in the opposite order from the book,
% since Matlab toggles left most dimension fastest.
% e.g, the first factor has scope [b a] not [a b], so that b toggles faster.
% This way the order of the numbers can be entered as in the book.
% However, the output's scope is always in sorted order...

a = 1; b = 2; c = 3;
sizes = [3 2 2]; 
F1 = factorMake([b a], sizes([b a]), [0.5 0.8 0.1 0 0.3 0.9]);
F2 = factorMake([c b], sizes([c b]), [0.5 0.7 0.1 0.2]);

F3 = factorMultiply(F1, F2);
factorPrint(F3)
for ai=1:sizes(a)
  for bi=1:sizes(b)
    for ci=1:sizes(c)
      assert(approxeq(F3.T(ai,bi,ci), F1.T(bi,ai) * F2.T(ci, bi)))
    end
  end
end

% Let us do the example in fig 7.9
F4 = factorMarginalize(F3, b);
assert(approxeq(F4.T(:), [0.33 0.05 0.24  0.51 0.07 0.39]))
