function F3 = factorMultiply(F1, F2)
% factorMultiply Elementwise multiplication of 2 tabular factors
% function F3 = factorMultiply(F1, F2)



F1 = factorSortScope(F1);
F2 = factorSortScope(F2);

scope3 = union(F1.scope, F2.scope);
sz3 = ones(1, length(scope3));
sz3(match(F1.scope, scope3)) = F1.sizes;
sz3(match(F2.scope, scope3)) = F2.sizes;
if length(sz3)==1
  T3 = ones(sz3, 1);
else
  T3 = ones(sz3);
end

F1 = factorExtendScope(F1, scope3, sz3);
F2 = factorExtendScope(F2, scope3, sz3);
T3 = F1.T(:) .* F2.T(:);
F3 = factorMake(scope3, sz3, T3);
