function F = factorSortScope(F)
% factorSortScope Permute the dimensions so that the scope is in ascending order
% function FS = factorSortScope(F)

[sortedScope, perm] = sort(F.scope);
if ~isequal(sortedScope, F.scope)
  F.T = permute(F.T, perm);
  F.scope = F.scope(perm);
  F.sizes = F.sizes(perm);
end
