function [fg, nodemap] = mrf2ToFactorGraph(mrf2)
  
% function to convert an mrf2
% to a factor graph.  Also returned is a node mapping 
% of the form vector->index that contains the relationship
% between nodes from the mrf2 that form a factor in the 
% factor graph (in the general case this is a vector->index
% mapping, but in this case its just a index->index mapping).
  
  
  adj = (mrf2.adj~=0);
  stateSizes = mrf2.stateSizes;
  % the indices if the factors become the edge numberings
  % in E
 % [E, nEdges] = assignEdgeNums(adj);
  N = length(mrf2.adj);
 % nFactors = nEdges/2;
  factors = {};
  nFac = 0;
  nodemap = cell(1,N);
  vars = 1:N;
  for (i = 1:N)
    for (j = (i+1):N)
      if (mrf2.adj(i,j) > 0)
	nFac = nFac+1;
	% create the factors for each edge in the graph
	pot = mrf2.pot{mrf2.adj(i,j)};
	factors{nFac} = ...
	    factorMake([i j], size(pot.T), reshape(pot.T, [1,prod(size(pot.T))]));
      end
    end
    nodemap{i} = [[i], i];	
  end
  
  fg.factors = factors;
  fg.vars = vars;
  fg.sizes = stateSizes;
