function outputFactorGraph(fg, outfilename)

fid = fopen(outfilename, 'W');

N = length(fg.vars);
M = length(fg.factors);
fprintf(fid, '%d %d\n', N, M); 
for i=1:N
    fprintf(fid, 'V %d %d\n', i-1, fg.sizes(i)); 
end

for i=1:M
    F = fg.factors{i};
    fprintf(fid, 'F '); 
    fprintf(fid, '%d ', F.scope-1); 
    fprintf(fid, '\n'); 
    for i=1:prod(F.sizes)
      u = ind2subv(F.sizes, i);
      fprintf(fid, '%d ', u-1);
      fprintf(fid, ': ');
      output(fid, F.T(i));
      fprintf(fid, '\n');
    end
%    fprintf(fid, '\n----------------\n');
end
fclose(fid);

function output(fid, x)
eps = 1e-300; % E.g. BMMF adds 1e-200 to all probs !!
if x < eps
    fprintf(fid, '-10000');
else
    fprintf(fid, '%f', log10(x));
end