function fg = sideChainToFactorGraph(side_chain_MRF)
%side_chain_MRF = load(side_chain_filename);

% init adj and pot
N = length(side_chain_MRF.adjMatrix);
adj = sparse(N,N);
pot = {};

% get the sizes of each var
for i=1:N
    stateSizes(i) = length(side_chain_MRF.Ls{i});
end

% make up pots and put indeces into adj
[a,b] = find(~isemptycell(side_chain_MRF.Psi));
k=length(a);
for i=1:k
    pot{i} = factorMake([a(i) b(i)], [stateSizes(a(i)) stateSizes(b(i))], side_chain_MRF.Psi{a(i), b(i)});
    adj(a(i), b(i)) = i;
end

% register everything with the mrf
mrf.stateSizes = stateSizes;
mrf.adj = adj;
mrf.pot = pot;
mrf.localEv = side_chain_MRF.Ls;

fg = mrf2ToFactorGraph(mrf);
fg = addEvidence(fg, mrf.localEv);